System.Gadget.onSettingsClosing = SettingsClosing;
var NetLib;
var interfaceCount=0;

function onLoad()
{
    debugLog("### LOAD SETTINGS ###");
    debugLog("GetLibrary (Settings)");
    NetLib = GetLibrary();
    initSettings();
}

function onUnload()
{
    debugLog("### UNLOAD SETTINGS ###");
}

function SettingsClosing(event)
{
	debugLog("SettingsClosing:" + event);
	if (event.closeAction == event.Action.commit) 
		saveSettings();
	event.cancel = false;
}

function initSettings()
{
    debugLog("initSettings");
    interfaceCount = NetLib.Initialize();
    fillInterfaceCombo();
    loadSettings();
}

function loadSettings()
{
    debugLog("loadSettings");
    
    debugLog("loadSettings:Interface->"+ System.Gadget.Settings.read("interface"));
    Interface.value = System.Gadget.Settings.read("interface");
    
    debugLog("loadSettings:DrawStyle->"+ System.Gadget.Settings.read("drawstyle"));
    DrawStyle.value = System.Gadget.Settings.read("drawstyle");
    
    debugLog("loadSettings:ScaleType->"+ System.Gadget.Settings.read("scaletype"));
    ScaleType.value = System.Gadget.Settings.read("scaletype");
    
    debugLog("loadSettings:ScaleSize->"+ System.Gadget.Settings.read("scalesize"));
    ScaleSize.value = System.Gadget.Settings.read("scalesize");
    
    debugLog("loadSettings:background->"+ System.Gadget.Settings.read("background"));
    background.value = System.Gadget.Settings.read("background");
    
    debugLog("loadSettings:vismode->"+ System.Gadget.Settings.read("vismode"));
    VisMode.value = System.Gadget.Settings.read("vismode");
    
    debugLog("loadSettings:barup->"+ System.Gadget.Settings.read("barup"));
    barup.value = System.Gadget.Settings.read("barup"); 
    
    debugLog("loadSettings:bardown->"+ System.Gadget.Settings.read("bardown"));
    bardown.value = System.Gadget.Settings.read("bardown");
}

function saveSettings()
{
    debugLog("saveSettings");
    
    debugLog("saveSettings:interface->"+ Interface.value); 
    System.Gadget.Settings.write("interface", Interface.value);
    
    debugLog("saveSettings:drawstyle->"+ DrawStyle.value); 
    System.Gadget.Settings.write("drawstyle", DrawStyle.value);
    
    debugLog("saveSettings:scaletype->"+ ScaleType.value); 
    System.Gadget.Settings.write("scaletype", ScaleType.value);
    
    debugLog("saveSettings:scalesize->"+ ScaleSize.value); 
    System.Gadget.Settings.write("scalesize", ScaleSize.value);
    
    debugLog("saveSettings:background->"+ background.value); 
    System.Gadget.Settings.write("background", background.value);
    
    debugLog("saveSettings:vismode->"+ VisMode.value); 
    System.Gadget.Settings.write("vismode", VisMode.value);
    
    debugLog("saveSettings:barup->"+ barup.value); 
    System.Gadget.Settings.write("barup", barup.value);
    
    debugLog("saveSettings:bardown->"+ bardown.value); 
    System.Gadget.Settings.write("bardown", bardown.value);
}

function fillInterfaceCombo()
{
    debugLog("fillInterfaceCombo");
    try 
    {
        for (var i = 0;i < interfaceCount; i++)
        {
            Interface.options[Interface.length] = new Option(i + ": " + System.Gadget.document.parentWindow.NetLib.Description(i), i);
        }
    }
	catch(err) 
	{
	    debugLog("fillInterfaceCombo: "+err.name+" - "+err.message)
	}
}